//+------------------------------------------------------------------+
//|                                              MarginCalculate.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//+------------------------------------------------------------------+
//|        .      |
//|             |
//|    ,          |
//|     .                                |
//+------------------------------------------------------------------+
double MarginCalculate(string symbol,double volume)
  {
   string first   =StringSubstr(symbol,0,3);         //  ,     EUR
   string second  =StringSubstr(symbol,3,3);         //  ,     USD
   string currency=AccountCurrency();                //  ,   USD
   double leverage=AccountLeverage();                //  ,   100
   double contract=MarketInfo(symbol,MODE_LOTSIZE);  //  ,  100000
   double bid     =MarketInfo(symbol,MODE_BID);      //  
//----      XXXYYY
   if(StringLen(symbol)!=6)
     {
      Print("MarginCalculate: '",symbol,"' must be standard forex symbol XXXYYY");
      return(0.0);
     }
//----   
   if(bid<=0 || contract<=0) 
     {
      Print("MarginCalculate: no market information for '",symbol,"'");
      return(0.0);
     }
//----     -  
   if(first==currency)   return(contract*volume/leverage);           // USDxxx
   if(second==currency)  return(contract*bid*volume/leverage);       // xxxUSD
//----   ,      
   string base=currency+first;                                       // USDxxx
   if(MarketInfo(base,MODE_BID)>0) return(contract/MarketInfo(base,MODE_BID)*volume/leverage);
//----  
   base=first+currency;                                              // xxxUSD
   if(MarketInfo(base,MODE_BID)>0) return(contract*MarketInfo(base,MODE_BID)*volume/leverage);
//----    
   Print("MarginCalculate: can not convert '",symbol,"'");
   return(0.0);
  }
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
   Print("Margin EURUSD: ",MarginCalculate("EURUSD",1.0));
   Print("Margin USDCHF: ",MarginCalculate("USDCHF",1.0));
   Print("Margin GBPCHF: ",MarginCalculate("GBPCHF",1.0));
   Print("Margin CHFJPY: ",MarginCalculate("CHFJPY",1.0));
//----
   return(0);
  }
//+------------------------------------------------------------------+